#include <iostream>

using namespace std;

class ListaGenerica {
	class Nodo {
	public:
		int info;
		Nodo *sig;
	};
	Nodo *raiz;
	void imprimir(Nodo *reco);
public:
	ListaGenerica();
	~ListaGenerica();
	int cantidad();
	void insertar(int pos, int x);
	void imprimir();
};

ListaGenerica::ListaGenerica()
{
	raiz = NULL;
}

ListaGenerica::~ListaGenerica()
{
	Nodo *reco = raiz;
	Nodo *bor;
	while (reco != NULL)
	{
		bor = reco;
		reco = reco->sig;
		delete bor;
	}
}


int ListaGenerica::cantidad()
{
	Nodo *reco = raiz;
	int cant = 0;
	while (reco != NULL)
	{
		cant++;
		reco = reco->sig;
	}
	return cant;
}

void ListaGenerica::insertar(int pos, int x)
{
	if (pos <= cantidad() + 1)
	{
		Nodo *nuevo = new Nodo();
		nuevo->info = x;
		if (pos == 1)
		{
			nuevo->sig = raiz;
			raiz = nuevo;
		}
		else
			if (pos == cantidad() + 1)
			{
				Nodo *reco = raiz;
				while (reco->sig != NULL)
				{
					reco = reco->sig;
				}
				reco->sig = nuevo;
				nuevo->sig = NULL;
			}
			else
			{
				Nodo *reco = raiz;
				for (int f = 1; f <= pos - 2; f++)
				{
					reco = reco->sig;
				}
				Nodo *siguiente = reco->sig;
				reco->sig = nuevo;
				nuevo->sig = siguiente;
			}
	}
}

void ListaGenerica::imprimir()
{
	imprimir(raiz);
}

void ListaGenerica::imprimir(Nodo *reco)
{
	if (reco != NULL) 
	{
		imprimir(reco->sig);
		cout<<reco->info << "-";
	}
}

void main()
{
	ListaGenerica *lg = new ListaGenerica();
	lg->insertar(1, 5);
	lg->insertar(2, 4);
	lg->insertar(3, 10);
	lg->imprimir();
	delete lg;
	cin.get();
}
